# Raspberry Pico micropython

![tag](Python)
![category](Raspberry)

Je travaille souvent avec des raspberry ou des arduinos.

La principale différence est que l'un est un ordinateur complet (os, wifi ...) communiquant , alors que les cartes arduino sont des cartes électroniques programmables dotée d’un microcontrôleur.

Pendant longtemps j'étais frusté: maintenir un raspberry est compliqué, nécessite du temps ... il s'agit d'un ordinateur complet. De l'autre côté un microcontrôleur possède son propre langage et ne possède pas les connectives wifi, bluetooth ...

ET bien RSP232 ou le Raspberry Pico W règle tout cela: on a un microcontroleur avec wifi et bluettoth sur lequel on peut placer un interpreteur (REPL) python


beaucoup de ressource sur https://www.micropython.fr/

## installation de la couche micropython

Il vous faut un Raspberry Pico W.

Il faut aller chercher sur https://micropython.org/download/RPI_PICO_W/ le flash pour votre carte.

Pour installer le flash rien de plus simple: vous connecter le Raspberry Pico sur l'ordinateur en appuyant sur le bouton BOOTSEL ... le Raspberry Pico apparait alors comme une clé usb ... vous copiez le fichier uf2 ...et à la fin de la copie le Raspberry Pico se desactive ... micropython est installé :-)


## comment utilisez micropython

Sur une carte la couche micropython va lancer au démarrage le fichier **boot.py**.  Ce fichier permet seulement de lancer le fichier **main.py**.
ce que vous devez faire est de créer le fichier main.py

Il ne faut modifier le fichier boot.py uniquement pour gérer la connexion wifi par exemple.


Pour faire et implementer votre main.py vous pouvez utiliser par exemple l'excellent editeur micropython d'arduino que vous pouvez trouver sur https://labs.arduino.cc/en/labs/micropython.

Pour le lancer

> ./arduino-lab-micropython-ide --no-sandbox

j'ai tout installer dans /opt/ArduinoMicroPython, et ajouter l'icone issue de github

je me suis créer un fichier /usr/share/applications/arduinomicropython.desktop contenant 

```
[Desktop Entry]
Name=Arduino MicroPython
Comment=Code Editing. Redefined.
GenericName=Text Editor
Exec=/opt/ArduinoMicroPython/arduino-lab-micropython-ide --no-sandbox
Icon=/opt/ArduinoMicroPython/icon.png
Type=Application
StartupNotify=false
StartupWMClass=Arduino MicroPython
Categories=Utility;TextEditor;Development;IDE;
MimeType=text/plain;inode/directory;application/x-codium-workspace;
Keywords=MicroPython;

X-Desktop-File-Install-Version=0.26
```

Il existe une version online super efficase https://lab-micropython.arduino.cc/

Exemple de code python permettant de faire clignoter le led du  Raspberry Pico:

```python
from machine import Pin
import time

led = Pin("LED", mode=Pin.OUT)

while True:
    led.on()
    time.sleep(1)
    led.off()
    time.sleep(1)
```



## comment reseter un Raspberry Pico

Il suffit de la flasher avec une image uf2 spécifique. Il se nomme flash_nuke.uf2 et on peut le trouver sur https://datasheets.raspberrypi.com/soft/flash_nuke.uf2.

vous connecter le Raspberry Pico sur l'ordinateur en appuyant sur le bouton BOOTSEL ... le Raspberry Pico apparait alors comme une clé usb ... vous copiez le fichier uf2 de reset


